{-
    Summer School in Advanced Functional Programming 2008

         Dependently Typed Programming in Agda

                     Ulf Norell

                     Lecture 1
-}

module Lecture1 where

-- Simple datatypes and pattern matching -------------------

{-
data Bool : Set where
  true  : Bool
  false : Bool

not : Bool -> Bool
not x = {! !}

data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

_+_ : Nat -> Nat -> Nat
n + m = {! !}

if_then_else_ : {A : Set} -> Bool -> A -> A -> A
if b then x else y = {! !}

id : {A : Set} -> A -> A
id x = x

_∘_ : {A B C : Set} -> (B -> C) -> (A -> B) -> A -> C
(f ∘ g) x = f (g x)

data List (A : Set) : Set where
  []   : List A
  _::_ : A -> List A -> List A

map : {A B : Set} -> (A -> B) -> List A -> List B
map f xs = {! !}

-- Some dependent types -----------------------------

--- Datatype families -------------------------------

-- Lists of a given length

data Vec (A : Set) : Nat -> Set where

vmap : {A B : Set}{n : Nat} -> (A -> B) -> Vec A n -> Vec B n
vmap f xs = {! !}

head : {A : Set}{n : Nat} -> Vec A (suc n) -> A
head xs = {! !}

-- Numbers smaller than a given number

data Fin : Nat -> Set where

-- A safe lookup function

_!_ : {A : Set}{n : Nat} -> Vec A n -> Fin n -> A
xs ! i = {! !}

-- Going the other way

tabulate : {n : Nat}{A : Set} -> (Fin n -> A) -> Vec A n
tabulate {n} f = {! !}

-- Programs as proofs ------------------------------------

--- Equality propositions

data _==_ {A : Set}(x : A) : A -> Set where

sym : {A : Set}(x y : A) -> x == y -> y == x
sym x y prf = {! !}

-- More on pattern matching ------------------------------

--- with: abstracting over intermediate computations

filter : {A : Set} -> (A -> Bool) -> List A -> List A
filter p xs = {! !}

data _⊆_ {A : Set} : List A -> List A -> Set where

lem-filter : {A : Set}(p : A -> Bool)(xs : List A) -> filter p xs ⊆ xs
lem-filter p xs = {! !}

data _≠_ : Nat -> Nat -> Set where

data Equal? (n m : Nat) : Set where
  eq  : n == m -> Equal? n m
  neq : n ≠ m -> Equal? n m

equal? : (n m : Nat) -> Equal? n m
equal? n m = {! !}
-}